; FIWR v0.3 by Roman Ovseytsev (arafel)
; [http://www.eccentrix.com/members/arafel] [tsech@mail.ru]
;
; only standard media - 1.4, 512b sectors is supported.
;
;
;
; Changelog:
;
; v0.3
;       - added image read support.
;	- cleaned a bit the code
;
; v0.2
;	- initial release



.386
.model flat, stdcall
option casemap :none


include \masm32\include\windows.inc
include \masm32\include\gdi32.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\Comctl32.inc
include \masm32\include\comdlg32.inc

includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\Comctl32.lib
includelib \masm32\lib\comdlg32.lib


S MACRO String:VARARG

	Local	string

.data
string	db String, 0
align 4
.code
        EXITM <ADDR string>
ENDM

S_O MACRO String:VARARG

	Local	string

.data
string	db String, 0
align 4
.code
        EXITM <offset string>
ENDM


WndProc		PROTO :DWORD,:DWORD,:DWORD,:DWORD


FSCTL_LOCK_VOLUME   		equ 622592
FSCTL_UNLOCK_VOLUME 		equ 638976
VWIN32_DIOC_DOS_DRIVEINFO 	equ 6
FILE_FLAG_DELETE_ON_CLOSE 	equ 4000000h
.data?

h_btn_0		dd ?
h_btn_1		dd ?
h_btn_2		dd ?
h_edit_0	dd ?
hDropdown	dd ?
h_chsdrv	dd ?
hStatustxt	dd ?
h_btn_3		dd ?
font_apply_cnt	equ ($-h_btn_0)/4

h_arch_fbuffer	dd ?
hInstance	dd ?
hWnd		dd ?
hFile		dd ?
hDisk		dd ?
arch_fsize	dd ?

hStatus		dd ?
hTimer		dd ?
hThread		dd ?
tmp_bytes	dd ?
pbar_value	dd ?
hIcon		dd ?
buffer		db 256 dup (?)

IOPACKET	STRUC
ioStartSector	dd ?
ioSectors	dw ?
ioBuffer	dd ?
IOPACKET	ENDS

DEVIOCTL_REGISTERS STRUC 
reg_EBX		dd ?
reg_EDX		dd ?
reg_ECX		dd ?
reg_EAX		dd ?
reg_EDI		dd ?
reg_ESI		dd ?
reg_Flags 	dd ?
DEVIOCTL_REGISTERS ENDS

dio		IOPACKET <?>
osver		OSVERSIONINFO <>
FileOpen	OPENFILENAME <>


.data

drive_strA	db "\\.\A:",0
drive_strB	db "\\.\B:",0
hVXD		db "\\.\VWIN32", 0

class_sta	db "Static", 0
class_btn	db "Button", 0
class_list	db "combobox", 0
class_edt	db "Edit", 0
class_fiwr	db "FIWR_class",0

FilterString	db "*.img Files", 0, "*.img", 0
		db "All Files", 0, "*.*", 0, 0

error3_t	db "Error reading from the floppy. Make sure diskette is inserted.",0
error4_t	db "Error writing to the floppy. Make sure diskette is inserted.",0
error8_t	db "The image size exceeds floppy disk capacity",0

progress_t	db "Writing...",0
progress_t1	db "Reading...",0
progressd_t	db "Done.",0

msgb_txt	db "             FIWR v0.3 by Roman Ovseytsev (arafel)",13,10,13,10
		db " Webpage:  http://www.eccentrix.com/members/arafel   ",13,10
		db " E-mail:   tsech@mail.ru",0

reg		DEVIOCTL_REGISTERS <offset dio, 0, -1, 7305h, 0, 0, 0>



.code

start PROC

	Local	wc:WNDCLASSEX
	Local	msg:MSG


	invoke	GetModuleHandle, 0
	mov	hInstance, eax

      	mov	wc.cbSize, sizeof WNDCLASSEX
      	mov	wc.style, CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW or CS_BYTEALIGNCLIENT
      	mov	wc.lpfnWndProc, offset WndProc
	mov	wc.cbClsExtra, 0
	mov	wc.cbWndExtra, 0
	mov	eax, hInstance
	mov	wc.hInstance, eax
	mov	wc.hbrBackground, COLOR_BTNFACE+1
	mov	wc.lpszMenuName, 0
	mov	wc.lpszClassName, offset class_fiwr
	invoke	LoadIcon, hInstance, 500
	mov	hIcon, eax
	mov	wc.hIcon, eax
	mov	wc.hIconSm, eax
	invoke	LoadCursor, 0, IDC_ARROW
	mov	wc.hCursor, eax
        invoke	RegisterClassEx, ADDR wc 

	invoke	GetSystemMetrics, SM_CXSCREEN
	shr	eax, 1
	sub	eax, 200
	mov	ebx, eax
	invoke 	GetSystemMetrics, SM_CYSCREEN
	shr	eax, 1 
	sub	eax, 115

	invoke	CreateWindowEx, WS_EX_LEFT, ADDR class_fiwr, S(" FIWR v0.3"), WS_VISIBLE or WS_CAPTION, ebx, eax, 400, 270, 0, 0, hInstance, 0
	mov	[hWnd], eax

	invoke	CreateWindowEx, WS_EX_STATICEDGE, ADDR class_btn, S("Image File"), BS_PUSHBUTTON or WS_CHILD or WS_VISIBLE or WS_BORDER or BS_PUSHLIKE, 18, 20, 65, 24, hWnd, 0, hInstance, 0
	mov	[h_btn_0], eax

	invoke	CreateWindowEx, WS_EX_STATICEDGE, ADDR class_btn, S("Write"), BS_PUSHBUTTON or WS_CHILD or WS_VISIBLE or WS_DISABLED or WS_BORDER, 7, 170, 100, 24, hWnd, 0, hInstance, 0
	mov	[h_btn_1], eax

	invoke	CreateWindowEx, WS_EX_STATICEDGE, ADDR class_btn, S("Read"), BS_PUSHBUTTON or WS_CHILD or WS_VISIBLE or WS_DISABLED or WS_BORDER, 7, 140, 100, 24, hWnd, 0, hInstance, 0
	mov	[h_btn_3], eax

	invoke	CreateWindowEx, WS_EX_STATICEDGE, ADDR class_btn, S("Exit"), BS_PUSHBUTTON or WS_CHILD or WS_VISIBLE or WS_BORDER, 316, 170, 70, 24, hWnd, 0, hInstance, 0
	mov	[h_btn_2], eax

	invoke CreateWindowEx, WS_EX_LEFT, ADDR class_btn, 0, BS_GROUPBOX or WS_CHILD or WS_VISIBLE, 7, 2, 380, 55, hWnd, 0, hInstance, 0

	invoke CreateWindowEx, WS_EX_LEFT, ADDR class_btn, 0, BS_GROUPBOX or WS_CHILD or WS_VISIBLE, 7, 60, 380, 55, hWnd, 0, hInstance, 0

	invoke CreateWindowEx, WS_EX_CLIENTEDGE, ADDR class_edt, 0, WS_DISABLED or WS_CHILD or WS_VISIBLE or WS_BORDER or ES_READONLY, -2, 208, 397, 18, hWnd, 0, hInstance, 0
	mov	[hStatustxt], eax

	invoke	CreateWindowEx, WS_EX_TRANSPARENT, ADDR class_sta, 0, SS_ICON or SS_CENTERIMAGE or SS_NOTIFY or WS_CHILD or WS_VISIBLE, 20, 73, 38, 38, hWnd, 0, hInstance, 0

        invoke SendMessage, eax, STM_SETIMAGE, IMAGE_ICON, hIcon

	invoke CreateWindowEx, WS_EX_LEFT, ADDR class_list, 0, CBS_DROPDOWNLIST or WS_CHILD or WS_VISIBLE, 247, 80, 130, 50, hWnd, 0, hInstance, 0
	mov	[hDropdown], eax

	invoke	GetLogicalDrives
	test	eax, eax
	je	error1
	mov	ebx, eax
	bt	eax, 0
	jnc	@f
	invoke	SendMessage, hDropdown, CB_ADDSTRING, 0, S("3 Floppy (A:)")
@@:	bt	ebx, 1
	jnc	@f
	invoke	SendMessage, hDropdown, CB_ADDSTRING, 0, S("3 Floppy (B:)")
@@:	invoke	SendMessage, hDropdown, CB_SETCURSEL, 0, 0

	invoke CreateWindowEx, WS_EX_LEFT, ADDR class_sta, S("Floppy Drive:"), WS_CHILD or WS_VISIBLE or SS_SIMPLE, 160, 85, 95, 25, hWnd, 0, hInstance, 0
	mov	[h_chsdrv], eax

	invoke	CreateWindowEx, WS_EX_CLIENTEDGE, ADDR class_edt, 0, WS_CHILD or WS_VISIBLE or WS_BORDER or ES_READONLY or ES_AUTOHSCROLL, 90, 20, 287, 24, hWnd, 0, hInstance, 0
	mov	[h_edit_0], eax

	invoke	CreateStatusWindow, WS_CHILD or WS_VISIBLE, 0, hWnd, 200
	mov	[hStatus], eax

	invoke	SendMessage, [hStatus], SB_SETTEXT, SBT_OWNERDRAW, 0

	invoke	GetStockObject, DEFAULT_GUI_FONT
	mov	edi, eax
	mov	esi, offset h_btn_0
	mov	ebx, font_apply_cnt
@@:	invoke	SendMessage, [esi], WM_SETFONT, edi, 0
	add	esi, 4
	dec	ebx
	jnz	@b

        invoke	ShowWindow, hWnd, SW_SHOWNORMAL
        invoke	UpdateWindow, hWnd

@@:	invoke	GetMessage, ADDR msg, 0, 0, 0
	test	eax, eax
	je	@f
	invoke	TranslateMessage, ADDR msg
	invoke	DispatchMessage, ADDR msg
	jmp	@b

@@:	invoke	VirtualFree, [h_arch_fbuffer], 0, MEM_RELEASE

error1:
	invoke	ExitProcess, msg.wParam

start ENDP

;################################################################################################

WndProc PROC hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

	.if uMsg == WM_COMMAND
	mov	eax, lParam

		.if eax == h_btn_0					; [image file]

		invoke	SetWindowText, hStatustxt, 0
		invoke  EnableWindow, h_btn_1, FALSE
		mov	[pbar_value], 0
		invoke	InvalidateRect, hStatus, 0, FALSE

		mov	FileOpen.lStructSize, sizeof FileOpen
		mov	eax, hWnd
		mov	FileOpen.hWndOwner, eax
		mov	edx, hInstance
		mov	FileOpen.hInstance, edx
		mov	FileOpen.lpstrFilter, offset FilterString
		mov	FileOpen.lpstrFile, offset buffer
		mov	FileOpen.nMaxFile, 256
		mov	FileOpen.Flags, OFN_PATHMUSTEXIST or OFN_HIDEREADONLY or OFN_EXPLORER or OFN_ENABLEHOOK
		mov	FileOpen.lpstrTitle, S_O("Choose an image file...")
		mov	FileOpen.lpfnHook, offset filedialog_hook
		invoke	GetOpenFileName, ADDR FileOpen
		test	eax, eax
		je	default
		invoke	SetWindowText, [h_edit_0], FileOpen.lpstrFile

		invoke  EnableWindow, [h_btn_3], TRUE
		invoke  EnableWindow, [h_btn_1], TRUE

		.elseif eax  == h_btn_1							; [write]


		invoke	CreateFile, FileOpen.lpstrFile, GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0
        	mov	[hFile], eax
        	cmp     eax, INVALID_HANDLE_VALUE
        	je      error1

        	invoke	GetFileSize, [hFile], 0
		cmp	eax, 1474560			; standart capacity
		ja	error8
		mov	edx, eax		
								; file size should be an integer multiple of sector size
		shr	eax, 9 ; div by 512
		imul	eax, 512
		cmp	eax, edx
		je	@f
		add	eax, 512
	@@:	mov	[arch_fsize], eax

		invoke	VirtualAlloc, 0, arch_fsize, MEM_COMMIT, PAGE_READWRITE
		mov     [h_arch_fbuffer], eax

		invoke	ReadFile, [hFile], [h_arch_fbuffer], [arch_fsize], ADDR tmp_bytes, 0
        	test	eax, eax
        	je	error2

		invoke	CloseHandle, [hFile]
		jmp	woppy

	error1:	invoke	SetWindowText, [hStatustxt], S("Error opening the file. Make sure it doesn't used by another application.")
		jmp	default

	error2:	invoke	SetWindowText, [hStatustxt], S("Error reading the file!")
		invoke	CloseHandle, [hFile]
		invoke	VirtualFree, [h_arch_fbuffer], 0, MEM_RELEASE
		jmp	default

	error8: invoke	SetWindowText, [hStatustxt], S("Image size of the selected file exceeds floppy disk capacity.")
		invoke	CloseHandle, [hFile]
		jmp	default

	woppy:
		mov	[pbar_value], 0

		;invoke  EnableWindow, h_btn_2, FALSE
		invoke  EnableWindow, h_btn_1, FALSE
		invoke  EnableWindow, h_btn_0, FALSE
		invoke  EnableWindow, h_btn_3, FALSE
		invoke	SetTimer, hWnd, 1030, 100, 0
		mov	[hTimer], eax
	
		mov	esi, offset nt_floppy_write
		mov	osver.dwOSVersionInfoSize, sizeof osver
		invoke	GetVersionEx, ADDR osver
		cmp	osver.dwPlatformId, VER_PLATFORM_WIN32_NT
		je	@f
		mov	esi, offset wx_floppy_write
	@@:	invoke	CreateThread, 0, 0, esi, 0, 0, ADDR hThread
		test	eax, eax
		je	@f
		invoke	CloseHandle, eax
		jmp	default
	@@:
		invoke	SetWindowText, [hStatustxt], S("Failed to create new thread.")
		invoke	KillTimer, [hWnd], [hTimer]

		.elseif eax == h_btn_3							; [read]

		invoke	VirtualAlloc, 0, 1474560, MEM_COMMIT, PAGE_READWRITE
		mov     [h_arch_fbuffer], eax

		mov	[pbar_value], 0

		invoke  EnableWindow, h_btn_3, FALSE
		invoke  EnableWindow, h_btn_1, FALSE
		invoke  EnableWindow, h_btn_0, FALSE
		invoke	SetTimer, hWnd, 1030, 100, 0
		mov	[hTimer], eax

		mov	esi, offset nt_floppy_read
		mov	osver.dwOSVersionInfoSize, sizeof osver
		invoke	GetVersionEx, ADDR osver
		cmp	osver.dwPlatformId, VER_PLATFORM_WIN32_NT
		je	@f
		mov	esi, offset wx_floppy_read
	@@:	invoke	CreateThread, 0, 0, esi, 0, 0, ADDR hThread
		test	eax, eax
		je	@f
		invoke	CloseHandle, eax
		jmp	default
	@@:
		invoke	SetWindowText, [hStatustxt], S("Failed to create new thread.")
		invoke	KillTimer, [hWnd], [hTimer]


		.elseif eax == h_btn_2							; [exit]

		jmp	exit

		.elseif wParam == STN_CLICKED						; [about]

		invoke	MessageBox, hWnd, ADDR msgb_txt, S("About..."), MB_OK

		.endif

	.elseif uMsg == WM_TIMER

	inc	[pbar_value]
	invoke	InvalidateRect, hStatus, 0, FALSE
	
	.elseif uMsg == WM_DRAWITEM
		.if	wParam == 200

		mov	ebx, lParam
		assume	ebx:ptr DRAWITEMSTRUCT

		invoke	GetStockObject, BLACK_BRUSH
		invoke	SelectObject, [ebx].hdc, eax

		mov	eax, pbar_value
		mov	ecx, [ebx].rcItem.right
		sub	ecx, [ebx].rcItem.left
		mul	ecx
		shr	eax, 9
		add	eax, [ebx].rcItem.left

		invoke	Rectangle, [ebx].hdc, [ebx].rcItem.left, [ebx].rcItem.top, eax, [ebx].rcItem.bottom

		assume	ebx:nothing

		.endif

	.elseif uMsg == WM_DESTROY

exit:	invoke	CloseHandle, [hDisk]
	invoke	PostQuitMessage, 0
        xor	eax, eax
	ret

	.endif

default:
	invoke	DefWindowProc, hWin, uMsg, wParam, lParam
	ret

WndProc ENDP

;################################################################################################

nt_floppy_write PROC

	mov	ebx, offset drive_strB
	invoke	SendMessage, hDropdown, CB_GETCURSEL, 0, 0
	test	eax, eax
	jne	@f
	mov	ebx, offset drive_strA
@@:	invoke	SetWindowText, [hStatustxt], ADDR progress_t

	invoke	CreateFile, ebx, GENERIC_WRITE, FILE_SHARE_WRITE, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL or FILE_FLAG_NO_BUFFERING, 0
	mov	[hDisk], eax	
	cmp	eax, INVALID_HANDLE_VALUE
	je	error

	invoke	DeviceIoControl, [hDisk], FSCTL_LOCK_VOLUME, 0, 0, 0, 0, ADDR tmp_bytes, 0

	invoke	WriteFile, [hDisk], [h_arch_fbuffer], [arch_fsize], ADDR tmp_bytes, 0
	test	eax, eax
	je	error1

	mov	[pbar_value], 512
	invoke	DeviceIoControl, [hDisk], FSCTL_UNLOCK_VOLUME, 0, 0, 0, 0, ADDR tmp_bytes, 0
	invoke	CloseHandle, [hDisk]
	invoke	VirtualFree, [h_arch_fbuffer], 0, MEM_RELEASE
	call	write_epilog
	invoke	SetWindowText, hStatustxt, ADDR progressd_t
	ret

error1:	invoke	DeviceIoControl, [hDisk], FSCTL_UNLOCK_VOLUME, 0, 0, 0, 0, ADDR tmp_bytes, 0
	invoke	CloseHandle, [hDisk]

error:	invoke	VirtualFree, [h_arch_fbuffer], 0, MEM_RELEASE
	call	write_epilog
	mov	[pbar_value], 0
	invoke	SetWindowText, hStatustxt, ADDR error4_t
	ret

nt_floppy_write ENDP

;################################################################################################

wx_floppy_write PROC

	mov	dio.ioStartSector, 0
	mov	eax, [arch_fsize]
	shr	eax, 9
	mov	dio.ioSectors, ax
	mov	eax, [h_arch_fbuffer]
	mov	dio.ioBuffer, eax

	invoke	SetWindowText, hStatustxt, ADDR progress_t

	invoke	CreateFile, ADDR hVXD, 0, 0, 0, 0, FILE_FLAG_DELETE_ON_CLOSE, 0
	mov	[hDisk], eax
	cmp	eax, INVALID_HANDLE_VALUE
	je	error

	mov	reg.reg_ESI, 1
	mov	reg.reg_EDX, 2	; drive B:
	invoke	SendMessage, hDropdown, CB_GETCURSEL, 0, 0
	test	eax, eax
	jne	@f
	mov	reg.reg_EDX, 1	; drive A:
@@:
	invoke	DeviceIoControl, hDisk, VWIN32_DIOC_DOS_DRIVEINFO, ADDR reg, SIZE reg, ADDR reg, SIZE reg, ADDR tmp_bytes, 0
	test	eax, eax
	je	error1

	mov	[pbar_value], 512
	invoke	SetWindowText, hStatustxt, ADDR progressd_t
	invoke	CloseHandle, [hDisk]
	invoke	VirtualFree, [h_arch_fbuffer], 0, MEM_RELEASE
	call	write_epilog
	ret

error1:	invoke	CloseHandle, [hDisk]
error:	invoke	VirtualFree, [h_arch_fbuffer], 0, MEM_RELEASE
	call	write_epilog
	mov	[pbar_value], 0
	invoke	SetWindowText, hStatustxt, ADDR error4_t
	ret

wx_floppy_write ENDP

;################################################################################################

nt_floppy_read PROC

	mov	ebx, offset drive_strB
	invoke	SendMessage, hDropdown, CB_GETCURSEL, 0, 0
	test	eax, eax
	jne	@f
	mov	ebx, offset drive_strA
@@:	invoke	SetWindowText, [hStatustxt], ADDR progress_t1

	invoke	CreateFile, ebx, GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL or FILE_FLAG_NO_BUFFERING, 0
	mov	[hDisk], eax	
	cmp	eax, INVALID_HANDLE_VALUE
	je	error

	invoke	DeviceIoControl, [hDisk], FSCTL_LOCK_VOLUME, 0, 0, 0, 0, ADDR tmp_bytes, 0

	invoke	ReadFile, [hDisk], [h_arch_fbuffer], 1474560, ADDR tmp_bytes, 0
	test	eax, eax
	je	error1

	invoke	CloseHandle, [hDisk]

	invoke	CreateFile, FileOpen.lpstrFile, GENERIC_WRITE, FILE_SHARE_WRITE, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
	mov	[hDisk], eax
	cmp	eax, INVALID_HANDLE_VALUE
	je	error1

	invoke	WriteFile, [hDisk], [h_arch_fbuffer], 1474560, ADDR tmp_bytes, 0
	test	eax, eax
	je	error1

	mov	[pbar_value], 512
	invoke	DeviceIoControl, [hDisk], FSCTL_UNLOCK_VOLUME, 0, 0, 0, 0, ADDR tmp_bytes, 0
	invoke	CloseHandle, [hDisk]
	invoke	VirtualFree, [h_arch_fbuffer], 0, MEM_RELEASE
	call	write_epilog
	invoke	SetWindowText, hStatustxt, ADDR progressd_t
	ret

error1:	invoke	DeviceIoControl, [hDisk], FSCTL_UNLOCK_VOLUME, 0, 0, 0, 0, ADDR tmp_bytes, 0
	invoke	CloseHandle, [hDisk]

error:	invoke	VirtualFree, [h_arch_fbuffer], 0, MEM_RELEASE
	call	write_epilog
	mov	[pbar_value], 0
	invoke	SetWindowText, hStatustxt, ADDR error3_t
	ret

nt_floppy_read ENDP

;################################################################################################

wx_floppy_read PROC

	mov	dio.ioStartSector, 0
	mov	eax, [arch_fsize]
	shr	eax, 9
	mov	dio.ioSectors, ax
	mov	eax, [h_arch_fbuffer]
	mov	dio.ioBuffer, eax

	invoke	SetWindowText, hStatustxt, ADDR progress_t

	invoke	CreateFile, ADDR hVXD, 0, 0, 0, 0, FILE_FLAG_DELETE_ON_CLOSE, 0
	mov	hDisk, eax
	cmp	eax, INVALID_HANDLE_VALUE
	je	error

	mov	reg.reg_ESI, 0
	mov	reg.reg_EDX, 2	; drive B:
	invoke	SendMessage, hDropdown, CB_GETCURSEL, 0, 0
	test	eax, eax
	jne	@f
	mov	reg.reg_EDX, 1	; drive A:
@@:
	invoke	DeviceIoControl, [hDisk], VWIN32_DIOC_DOS_DRIVEINFO, ADDR reg, SIZE reg, ADDR reg, SIZE reg, ADDR tmp_bytes, 0
	test	eax, eax
	je	error1

	invoke	CloseHandle, [hDisk]

	invoke	CreateFile, FileOpen.lpstrFile, GENERIC_WRITE, FILE_SHARE_WRITE, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
	mov	[hDisk], eax
	cmp	eax, INVALID_HANDLE_VALUE
	je	error1

	invoke	WriteFile, [hDisk], [h_arch_fbuffer], 1474560, ADDR tmp_bytes, 0
	test	eax, eax
	je	error1

	mov	[pbar_value], 512
	invoke	SetWindowText, hStatustxt, ADDR progressd_t
	invoke	CloseHandle, [hDisk]
	invoke	VirtualFree, [h_arch_fbuffer], 0, MEM_RELEASE
	call	write_epilog
	ret

error1:	invoke	CloseHandle, [hDisk]
error:	invoke	VirtualFree, [h_arch_fbuffer], 0, MEM_RELEASE
	call	write_epilog
	invoke	SetWindowText, hStatustxt, ADDR error3_t
	mov	[pbar_value], 0
	ret

wx_floppy_read ENDP

;################################################################################################

filedialog_hook PROC hdlg:DWORD, uiMsg:DWORD, wParam:DWORD, lParam:DWORD

	.if uiMsg == WM_INITDIALOG

	invoke	GetParent, hdlg
	invoke	SendMessage, eax, CDM_SETCONTROLTEXT, IDOK, S("OK")

	.endif

	xor	eax, eax
	ret

filedialog_hook ENDP

;################################################################################################

write_epilog PROC

	invoke	KillTimer, hWnd, hTimer
	invoke	InvalidateRect, hStatus, 0, FALSE
	invoke  EnableWindow, h_btn_3, TRUE
	invoke  EnableWindow, h_btn_1, TRUE
	invoke  EnableWindow, h_btn_0, TRUE
	ret

write_epilog ENDP

end start